import { FirestoreProvider } from "../Collections";
import { IDocDetail } from "polar-shared/src/metadata/IDocDetail";
import { IDStr, URLStr } from "polar-shared/src/util/Strings";
import { SlugStr } from "polar-shared/src/util/Slugs";
export interface BaseDocPreview extends IDocDetail {
    readonly id: IDStr;
    readonly urlHash: IDStr;
    readonly url: URLStr;
    readonly category?: string;
}
export interface DocPreviewCached extends BaseDocPreview {
    readonly docHash: IDStr;
    readonly datastoreURL: URLStr;
    readonly cached: true;
    readonly slug: SlugStr | undefined;
}
export interface DocPreviewUncached extends BaseDocPreview {
    readonly cached: false;
}
export declare type DocPreview = DocPreviewCached | DocPreviewUncached;
export interface Range {
    readonly start: IDStr;
    readonly end: IDStr;
}
export interface ListOpts {
    readonly size: number;
    readonly range?: Range;
}
export declare class DocPreviews {
    static firestoreProvider: FirestoreProvider;
    private static COLLECTION;
    private static collections;
    static set(doc: DocPreview): Promise<DocPreview>;
    static list(opts: ListOpts): Promise<ReadonlyArray<DocPreview>>;
    static get(id: IDStr): Promise<DocPreview | undefined>;
}
