import { FirestoreProvider, UserIDStr } from "../Collections";
import { ISODateTimeString } from "polar-shared/src/metadata/ISODateTimeStrings";
import { VersionStr } from "polar-shared/src/util/Version";
import { IDStr } from "polar-shared/src/util/Strings";
import { MachineID } from "polar-shared/src/util/MachineIDs";
import { AppRuntimeID } from "polar-shared/src/util/AppRuntime";
import { PlatformStr } from "polar-shared/src/util/Platforms";
import { Device } from "polar-shared/src/util/Devices";
export declare class Heartbeats {
    static firestoreProvider: FirestoreProvider;
    private static COLLECTION;
    private static collections;
    static write(uid: UserIDStr | undefined): Promise<void>;
    static create(uid: UserIDStr | undefined): HeartbeatsInit;
}
export interface HeartbeatsInit {
    readonly id: IDStr;
    readonly created: ISODateTimeString;
    readonly uid: UserIDStr | undefined;
    readonly platform: PlatformStr;
    readonly machine: MachineID;
    readonly version: VersionStr;
    readonly runtime: AppRuntimeID;
    readonly device: Device;
}
export interface Heartbeat extends HeartbeatsInit {
}
