import { Image } from './Images';
import { TagStr } from "polar-shared/src/tags/Tags";
import { PlainTextStr, URLStr } from "polar-shared/src/util/Strings";
export interface ProfileInit {
    readonly name?: string;
    readonly image?: Image;
    readonly handle?: HandleStr;
    readonly bio?: PlainTextStr;
    readonly tags?: ReadonlyArray<TagStr>;
    readonly links?: ReadonlyArray<URLStr>;
    readonly location?: string;
}
export interface Profile extends ProfileInit {
    readonly id: ProfileIDStr;
}
export declare type ProfileIDStr = string;
export declare type HandleStr = string;
export declare type UserIDStr = string;
export declare type EmailStr = string;
export interface ProfileIDRecord {
    readonly profileID?: ProfileIDStr;
}
export declare type ProfileRecordTuple<T> = [T, Profile | undefined];
