import { IDStr } from "polar-shared/src/util/Strings";
import { FirestoreProvider, UserIDStr } from "../Collections";
import { RepetitionMode, StageCounts } from "polar-spaced-repetition-api/src/scheduler/S2Plus/S2Plus";
import { ISODateTimeString } from "polar-shared/src/metadata/ISODateTimeStrings";
export declare class SpacedRepStats {
    static firestoreProvider: FirestoreProvider;
    private static COLLECTION;
    private static collections;
    static write(uid: UserIDStr, spacedRepStat: SpacedRepStat): Promise<SpacedRepStatRecord>;
    static list(uid: UserIDStr, mode: RepetitionMode, type: StatType): Promise<ReadonlyArray<SpacedRepStatRecord>>;
    static hasStats(uid: UserIDStr): Promise<boolean>;
}
export interface IStat {
    readonly created: ISODateTimeString;
    readonly mode: RepetitionMode;
}
export declare type StatType = 'queue' | 'completed';
export interface QueueStat extends IStat, StageCounts {
    readonly type: 'queue';
}
export interface CompletedStat extends IStat, StageCounts {
    readonly type: 'completed';
}
export interface ISpacedRepStatRecord {
    readonly id: IDStr;
    readonly uid: UserIDStr;
    readonly created: ISODateTimeString;
}
export declare type SpacedRepStat = QueueStat | CompletedStat;
export declare type SpacedRepStatRecord = SpacedRepStat & ISpacedRepStatRecord;
