import { PlatformStr } from "polar-shared/src/util/Platforms";
import { FirestoreProvider, UserIDStr } from "../Collections";
import { ISODateTimeString } from "polar-shared/src/metadata/ISODateTimeStrings";
import { VersionStr } from "polar-shared/src/util/Version";
import { MachineID } from "polar-shared/src/util/MachineIDs";
export declare class UserMachines {
    static firestoreProvider: FirestoreProvider;
    private static COLLECTION;
    private static collections;
    static update(): Promise<void>;
}
export declare class UserMachineInits {
    static create(): UserMachineInit;
}
export interface IScreen {
    readonly width: number;
    readonly height: number;
}
export declare type RevType = 'v1';
export interface UserMachineInit {
    readonly id: MachineID;
    readonly rev: RevType;
    readonly platform: PlatformStr;
    readonly version: VersionStr;
    readonly screen: IScreen;
}
export interface UserMachine extends UserMachineInit {
    readonly user_id: UserIDStr;
    readonly lastUpdated: ISODateTimeString;
    readonly created: ISODateTimeString;
}
